#!/usr/bin/env wish

# Copyright (c) 2002-2008, Botik-Technologies, Ltd.
# See license.txt for more information.

package require Tclx

proc sendmail {body {btrep {0 {}}}} {
    global env whoami_ botik
    if {[catch {
        package require mime 1.4
        package require smtp 1.3.5
		set ::reportNotSent 1
        set subj  [lindex $btrep 1]
        set btrep [lindex $btrep 0]
        # Узнаём о пользователе с помощью сервиса WhoAmI
        _whoAmI
        set myinfo ""
        set myemail ""
        if {[array exists whoami_]} {
            set all [array get whoami_]
            foreach {elt val} $all {
                if {[lempty $elt]} {continue}
                set myinfo "$myinfo\n:$elt:$val"
                if {$elt eq "Time"} {catch {set myinfo "$myinfo\n:Client time:$botik(cli_time)"}}
            }
        }
        set myinfo "$myinfo\n[systemInfo]"
        # Узнаём от кого письмо
        if {[catch {set from ${env(USERNAME)}-$whoami_(UserName)}]} {
            if {[catch {set from ${env(USERNAME)}-$env(USERDOMAIN)}]} {
                set from "BotikTools user"
            }
        }
        if {[info exists ::wReport(From)] && ![lempty $::wReport(From)]} {
            set from "\"$from\" <$::wReport(From)>"
            set myemail $::wReport(From)
        } elseif {[info exists whoami_(Email)] && ![lempty $whoami_(Email)]} {
            set from "\"$from\" <$whoami_(Email)>"
            set myemail $whoami_(Email)
        }
        set from    [tokoi $from]
        set replyto $myemail
        # имя и версия программы
        if {[info exists ::ping(ver)]} {
            set pname "BotikTester v.$::ping(ver)"
        } elseif {[info exists ::botikkey(ver)]} {
            set pname "BotikKey v.$::botikkey(ver)"
        } elseif {[info exists ::plot(version)]} {
            set pname "BotikMap v.$::plot(version)"
        } else {
            set pname "BotikTools"
        }
        # Тема письма
        if {!$btrep} {
            set subject [tokoi BotikTools\::[lindex [split $body "\n"] 0]]
        } else {
            set subject [tokoi $subj]
        }
        # Тело письма
        if {!$btrep} {
            set body [tokoi "$pname\n$myinfo\n\n$body"]
        } else {
            set body [tokoi $body]
        }
        # if not BotikMap and not BotikTester
        if {![info exists ::plot(version)] && !$btrep} {
            append body [tokoi "\n\nСреда приложения:\n\n[getEnv]"]
        }
        # Отсылка письма
        set parts [mime::initialize -canonical "text/plain; charset=koi8-r; format=flowed" -string $body -encoding 8bit]
        if {!$btrep && [array exists ::ping] && [file exists $::ping(cmdlog)]} {
            traceOff
            set file [addToArchive $::ping(cmdlog)]
            lappend parts [mime::initialize -canonical "application/data; name=\"[file tail $file]\"" -file $file]
        }
        if {[array exists ::botikkey] && [file exists $::botikkey(log)]} {
            set file [addToArchive $::botikkey(log)]
            lappend parts [mime::initialize -canonical "application/data; name=\"[file tail $file]\"" -file $file]
        }
        if {[info exists ::plot(version)]} {
	        # dump all environment to a file, compress and send it
			set fd [open progenv.txt w]
	        puts $fd [getEnv]
			close $fd
            set arch [addToArchive progenv.txt]
            if {[file size $arch] <= 9*1024*1024} {
            	lappend parts [mime::initialize -canonical "application/data; name=\"[file tail $arch]\"" -file $arch]
            }
        }
        if {$btrep} {
            set devemails $::ping(repair)
        } else {
            set devemails "botik-tools@botik.ru"
        }
        if {[llength $parts] > 1} {
            set token [mime::initialize -canonical "multipart/mixed" -parts $parts]
        } else {
            set token [mime::initialize -canonical "text/plain; charset=koi8-r; format=flowed; reply-type=original" -string $body -encoding 8bit]
        }
        smtp::sendmessage $token \
        	-originator $from \
            -recipients $devemails \
            -servers    mail.$::net(domain) \
	        -header     [list To $devemails] \
            -header     [list Subject $subject]
        mime::finalize $token -subordinates all
#        -header     [list From $from]
#        -header     [list Reply-To $replyto]
    }]} {
    	unset ::reportNotSent
        if {$btrep} {
            set ::mail_log    {}
            set ::mail_status 1
            set ::mail_result $::errorInfo
        }
        set msg "Отправка отчёта не удалась.\n$::errorInfo"
        tk_messageBox -icon error -type ok -title "Ошибка" -message "$msg"
    } else {
    	unset ::reportNotSent
        if {$btrep} {
            set ::mail_log    {}
            set ::mail_status 0
            set ::mail_result {}
        } else {
            set msg "Отчёт успешно отправлен."
            tk_messageBox -icon info -type ok -title "Сообщение" -message "$msg"
        }
    }
    #if {!$btrep && [info exists ::ping(ver)]} {traceon}
}
proc addToArchive {file} {
    set res [catch {exec ../bin/bzip2.exe -zkf --best "$file"}]
    if {!$res} {
        return ${file}.bz2
    } else {
        return $file
    }
}
proc asksendmail {body} {
    bell
    if {[lempty $body]} {return}
    # Если нужно спрашивать
    set msg "Обнаружена ошибка. Разрешаете ли Вы отправку разработчикам\nавтоматически составленного отчёта об ошибке?"
    set ans [tk_messageBox -icon question -type yesno -title "Вопрос" -message "$msg"]
    if {$ans eq "yes"} {
        sendmail $body
    }
}
proc bytesFmt {x} {
    set k 0
    set y $x
    if {$y < 1000} {
        return [format "%7.0f " $y]
    }
    for {set k 0} { ($k <= 7) && (double($y) > 999.0) } {incr k} {
        set y [expr double($y) / 1024.0]
    }
    # "E" ("exa-", "экза-") обозначает квантильон, или 2 в степени 60
    return [format "%7.3f%1s" $y [lindex { " " "k" "M" "G" "T" "P" "E" } $k]]
}
# Данные об ОС, памяти и процессоре
proc systemInfo {} {
    set info {}
 try_eval {
  if {[windowsPlatform]} {
    if {$::tcl_platform(os) ne "Windows NT"} {
        return "\[полная информация о системе недоступна\]\n:OS:$::tcl_platform(os) $::tcl_platform(osVersion)"
    }
    package require twapi
    set osdescr [twapi::get_os_description]
    set meminfo [twapi::get_memory_info -totalphysical -availphysical]
    set phys    [string trim [bytesFmt [lindex $meminfo 1]]]
    set avail   [string trim [bytesFmt [lindex $meminfo 3]]]
    set cpufreq [lindex [twapi::get_processor_info {} -processorspeed] 1]
    set numofcpus 1
    catch {set numofcpus $::env(NUMBER_OF_PROCESSORS)}
  } else {
    # OS description
    catch "exec uname --kernel-name --release --machine --operating-system" osdescr

    # memory information
    set freeregexpr {^[a-zA-Z\s:]+(\d+)[\s\d]+[-/+a-zA-Z\s:]+\d+\s+(\d+).*$}
    #                          phys^^^                   used^^^free^^^
    catch "exec free -m" freeres
    regexp $freeregexpr $freeres skip phys avail
    set phys "$phys M"
    set avail "$avail M"

    # cpu information
    set cpumhzregexpr {^[a-zA-Z\s:]+(\d+\.?\d*).*$}
    #                             MHz^^^^^^^^^
    catch "exec grep MHz /proc/cpuinfo" cpumhz
    regexp $cpumhzregexpr $cpumhz skip cpufreq
    set n [regsub -all "\n" $cpumhz "." res]
    set numofcpus [incr n]
  }
    set info    ":OS:$osdescr"
    append info "\n:Total physical memory:$phys"
    append info "\n:Avail physical memory:$avail"
    append info "\n:CPU frequency:$cpufreq Mhz"
    if {$numofcpus > 1} {
      append info "\n:Number of CPUs:$numofcpus"
    }
    append info [netInfo]
 } {
    return "$info\nИнформация о системе недоступна:\n$errorInfo\n"
 }
    return $info
}
proc netInfo {} {
    set res {}
  try_eval {
    if {[windowsPlatform]} {
        if {![twapi::min_os_version 5]} {return}
        array set status_labels {
            nonoperational "Disconnected"
            disconnected   "Disconnected"
            wanconnecting  "Connecting"
            wanconnected   "Connected"
            operational    "Connected"
        }
        array set netinfo [twapi::get_network_info -all]
        append res "\n:Domain:$netinfo(-domain)"
        append res "\n:Hostname:$netinfo(-hostname)"
        foreach ifx [twapi::get_netif_indices] {
            array set netif [twapi::get_netif_info $ifx -all]
            set netif(-dnsservers) [join $netif(-dnsservers) ", "]
            if {[info exists status_labels($netif(-operstatus))]} {
                set netif(-operstatus) $status_labels($netif(-operstatus))
            }
            set addrs {}
            foreach addr $netif(-ipaddresses) {
                lappend addrs "[lindex $addr 0] netmask [lindex $addr 1]"
            }
            set netif(-ipaddresses) [join $addrs ", "]
            append res "\n"
            append res "\n:Adapter:$netif(-description)"
            foreach {opt label} {
                -operstatus     ":Status:"
                -mtu            ":MTU size:"
                -ifname         ":Interface name:"
                -type           ":Interface type:"
                -speed          ":Speed:"
                -ipaddresses    ":IP address:"
                -defaultgateway ":Default gateway:"
                -dhcpserver     ":DHCP server:"
                -dnsservers     ":DNS servers:"
            } {
                catch {
                    if {$opt eq "-speed"} {
                        set speed [expr $netif($opt) / 1000000]
                        append speed " Mbit/s"
                        append res "\n$label$speed"
                    } else {
                        append res "\n$label$netif($opt)"
                    }
                }
            }
        }
    } else {
        # hostname and domain
        catch "exec hostname --domain" domain
        catch "exec hostname --short" hostname
        append res "\n:Domain:$domain"
        append res "\n:Hostname:$hostname"
        # list of DNS servers
        set resolvid [open "/etc/resolv.conf"]
        set resolv   [read $resolvid]
        close $resolvid
        set resexp {nameserver\s+([.0-9]+)}
        set dnssep ""
        set dnss   ""
        foreach str [split $resolv \n] {
            if {[regexp $resexp $str skip dnsip]} {
                append dnss "$dnssep $dnsip"
                set dnssep ","
            }
        }
        # list of network interfaces
        set devfid [open "/proc/net/dev"]
        set devs   [read $devfid]
        close $devfid
        set devreg {^\s+([a-zA-Z0-9]+):.*$}
        #         devname^^^^^^^^^^^^
        set ifconfigreg  {^.*Link encap:([a-zA-Z ]+).*inet addr:([.0-9]+).*Mask:([.0-9]+).*MTU:([0-9]+).*$}
        set ifconfigreg1 {^.*Link encap:([a-zA-Z ]+).*MTU:([0-9]+).*$}
        foreach dev [split $devs \n] {
            if {[regexp $devreg $dev skip devname]} {
                set status  ""
                set mtu     ""
                set type    ""
                set ip      ""
                set mask    ""
                set gw      ""
                set dnssout ""
                set ipmask  ""
                catch "exec /sbin/ifconfig $devname" ifcout
                if {[regexp $ifconfigreg $ifcout skip type ip mask mtu]} {
                    set status "Connected"
                    set ipmask "$ip mask $mask"
                    # get default dateway
                    set routereg {^.*\n0.0.0.0\s+([.0-9]+).*$}
                    catch "exec /sbin/route -n" routeout
                    regexp $routereg $routeout skip gw
                    # set list of dns servers
                    if {$devname != "lo"} {
                       set dnssout $dnss
                    }
                } elseif {[regexp $ifconfigreg1 $ifcout skip type mtu]} {
                    set status "Disconnected"
                }
                append res "\n\n:Adapter:"
                append res "\n:Status:$status"
                append res "\n:MTU size:$mtu"
                append res "\n:Interface name:$devname"
                append res "\n:Interface type:$type"
                append res "\n:Speed:"
                append res "\n:IP address:$ipmask"
                append res "\n:Default gateway:$gw"
                append res "\n:DHCP server:"
                append res "\n:DNS servers:$dnssout"
             }
         }
     }
  } {
    return "$res\nИнформация о сетевой конфигурации недоступна:\n$errorInfo\n"
  }
    return $res
}
proc _whoAmI {} {
    global whoami_ botik
    array unset whoami_
    if {[info exists ::ping(url_whoami)]} {
        set whoamiurl $::ping(url_whoami)
    } elseif {[info exists ::botikkey(url_whoami)]} {
        set whoamiurl $::botikkey(url_whoami)
    } elseif {[info exists ::whoamiurl]} {
    	set whoamiurl $::whoamiurl
    } else {
        return
    }
    set botik(cli_time) ""
    catch {http::geturl $whoamiurl -handler whoamiHandler -timeout 6000}
}
proc ftime {} {
    return [clock format [clock seconds] -format "%Y-%m-%d %X"]
}
proc whoamiHandler {socket token} {
    global whoami_ botik
    gets $socket line
    set spl   [split $line ":"]
    set kword [lindex $spl 1]
    set value [string range $line [expr [string length $kword] + 2] end]
    set whoami_($kword) $value
    if {$kword eq "Time"} {
        set botik(cli_time) [ftime]
    }
    return
}
proc tokoi {str} {
    return [encoding convertto koi8-r $str]
}
# получает глобальное окружение (переменные и их значения)
proc getEnv {} {
    set globals [lsort [info globals]]
    set res     ""
    set vars    {}
    set arrays  {}
    set exclusions {bkOptions env errorInfo help wReport whoami_ bkLog conn zooms types states}
    foreach var $globals {
        if {[lcontain $exclusions $var]} {continue}
        if {[string match tcl_* $var]} {continue}
        if {[string match tk_* $var]} {continue}
        if {[string match auto_* $var]} {continue}
        if {[string match arg* $var]} {continue}
        if {[array exists ::$var]} {
            lappend arrays $var
        } else {
            lappend vars $var
        }
    }
    foreach var $vars {
        append res "-> [list set $var [set ::$var]]\n"
    }
    foreach var $arrays {
        append res "-> [list array set $var [array get ::$var]]\n"
    }
    return $res
}
